<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfErrorDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfErrorDetails
 * @subpackage Arrays
 */
class ArrayOfErrorDetails extends AbstractStructArrayBase
{
    /**
     * The ErrorDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ErrorDetails[]
     */
    public $ErrorDetails;
    /**
     * Constructor method for ArrayOfErrorDetails
     * @uses ArrayOfErrorDetails::setErrorDetails()
     * @param \StructType\ErrorDetails[] $errorDetails
     */
    public function __construct(array $errorDetails = array())
    {
        $this
            ->setErrorDetails($errorDetails);
    }
    /**
     * Get ErrorDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ErrorDetails[]|null
     */
    public function getErrorDetails()
    {
        return isset($this->ErrorDetails) ? $this->ErrorDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setErrorDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrorDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorDetailsForArrayConstraintsFromSetErrorDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfErrorDetailsErrorDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfErrorDetailsErrorDetailsItem instanceof \StructType\ErrorDetails) {
                $invalidValues[] = is_object($arrayOfErrorDetailsErrorDetailsItem) ? get_class($arrayOfErrorDetailsErrorDetailsItem) : sprintf('%s(%s)', gettype($arrayOfErrorDetailsErrorDetailsItem), var_export($arrayOfErrorDetailsErrorDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ErrorDetails property can only contain items of type \StructType\ErrorDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ErrorDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorDetails[] $errorDetails
     * @return \ArrayType\ArrayOfErrorDetails
     */
    public function setErrorDetails(array $errorDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($errorDetailsArrayErrorMessage = self::validateErrorDetailsForArrayConstraintsFromSetErrorDetails($errorDetails))) {
            throw new \InvalidArgumentException($errorDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($errorDetails) || (is_array($errorDetails) && empty($errorDetails))) {
            unset($this->ErrorDetails);
        } else {
            $this->ErrorDetails = $errorDetails;
        }
        return $this;
    }
    /**
     * Add item to ErrorDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorDetails $item
     * @return \ArrayType\ArrayOfErrorDetails
     */
    public function addToErrorDetails(\StructType\ErrorDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ErrorDetails) {
            throw new \InvalidArgumentException(sprintf('The ErrorDetails property can only contain items of type \StructType\ErrorDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ErrorDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ErrorDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ErrorDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ErrorDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ErrorDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ErrorDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ErrorDetails
     */
    public function getAttributeName()
    {
        return 'ErrorDetails';
    }
}
